// v싅FAN (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	int dn=0;
	unsigned char id1[] = "BASE BALL    Sys ";
	unsigned char id2[] = "TELENET STADIUM";

	// Disk 1
	struct fpos md1a[] =
	{
		{ 0x04, 0x04, 0x0000, 0x0400 },	// X1   YOPX03
		{ 0x09, 0x01, 0x0000, 0x0800 },	// X1   YVX103
		{ 0x09, 0x05, 0x0000, 0x0800 },	// X1   YVX202
		{ 0x0a, 0x04, 0x0000, 0x0800 },	// XHPP1
		{ 0x0b, 0x05, 0x0000, 0x1000 },	// XHPP2
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	// Disk 1 (PSG)
	struct fpos md1b[] =
	{
		{ 0x05, 0x01, 0x0000, 0x0800 },	// MSX YOPm01
		{ 0x09, 0x03, 0x0000, 0x0800 },	// MSX YVm102
		{ 0x0a, 0x02, 0x0000, 0x0800 },	// MSX YVM201
		{ 0x0b, 0x02, 0x0000, 0x0c00 },	// 
		{ 0x0c, 0x04, 0x0000, 0x0800 },	// 
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	// Disk 1 (̑)
	struct fpos md1c[] =
	{
		{ 0x0d, 0x03, 0x0000, 0x0200 },	// PC88  YOPp02
		{ 0x0d, 0x05, 0x0000, 0x0200 },	// PC88  YOPp02
		{ 0x24, 0x04, 0x0300, 0x0500 },	// X1    YBX103 (Y)
		{ 0x40, 0x01, 0x0000, 0x0800 },	// PC88  YVp102
		{ 0x40, 0x03, 0x0000, 0x0800 },	// PC88  YVp201
		{ 0x41, 0x01, 0x0000, 0x0800 },	// PC88  HOMp02
		{ 0x41, 0x03, 0x0000, 0x0800 },	// PC88  HOMp02
		{ 0x42, 0x01, 0x0000, 0x0800 },	// PC88  HOMp02
		{ 0x42, 0x03, 0x0000, 0x0800 },	// PC88  HOMp02
		{ 0x42, 0x05, 0x0000, 0x0600 },	// PC88  YOPp02 (S~?)
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	// Disk 2 (OPM)
	struct fpos md2a[] =
	{
		{ 0x12, 0x01, 0x0000, 0x0800 },	// X1    YBX103
		{ 0x12, 0x03, 0x0000, 0x0800 },	// X1    YBX202
		{ 0x12, 0x05, 0x0000, 0x0200 },	// X1    HOMX03
		{ 0x12, 0x05, 0x0200, 0x0200 },	// INNING CHANGE
		{ 0x13, 0x01, 0x0000, 0x0800 },	// X1    YBX302
		{ 0x13, 0x03, 0x0000, 0x0800 },	// X1    YBX403
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	// Disk 2 (PSG)
	struct fpos md2b[] =
	{
		{ 0x10, 0x01, 0x0000, 0x0800 },	// MSX   YBm102
		{ 0x10, 0x03, 0x0000, 0x0800 },	// MSX   YBm202
		{ 0x10, 0x05, 0x0000, 0x0200 },	// MSX   HOMm02
		{ 0x10, 0x05, 0x0200, 0x0200 },	// INNING CHANGE
		{ 0x11, 0x01, 0x0000, 0x0800 },	// MSX   YBm302
		{ 0x11, 0x03, 0x0000, 0x0800 },	// MSX   YBm402
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	// Disk 2 (̑)
	struct fpos md2c[] =
	{
//		{ 0x4f, 0x04, 0x0000, 0x0500 },	// PC88  YBP401 (S~?)
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	if (argc==3)
	{
		dn = atoi(argv[2]);
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		disk.SetRecordRange(0x01,0x05);
		// IPL̕ŃfBXN𔻒
		if ((!memcmp(&buff[1], id1, sizeof(id1)-1) && dn!=2) || dn==1)
		{
			printf("DISK 1 F܂.\n");
			// CvO
			fcut("OPMDRV", 0x01, 0x00, 0x01, 0x04, 0x03, 0x0000, 0x1000);
			fcut("PSGDRV", 0x01, 0x00, 0x01, 0x01, 0x03, 0x0000, 0x0c00);

			// ȃf[^̐؂o
			for (i=0; md1a[i].sec; i++)
			{
				sprintf(fname,"MA0%02d",i);
				fcut(fname, md1a[i].trk, md1a[i].trk>>1, md1a[i].trk&1, md1a[i].sec, 0x03, md1a[i].ofs, md1a[i].size);
			}
			for (i=0; md1b[i].sec; i++)
			{
				sprintf(fname,"MB0%02d",i);
				fcut(fname, md1b[i].trk, md1b[i].trk>>1, md1b[i].trk&1, md1b[i].sec, 0x03, md1b[i].ofs, md1b[i].size);
			}
			for (i=0; md1c[i].sec; i++)
			{
				sprintf(fname,"MC0%02d",i);
				fcut(fname, md1c[i].trk, md1c[i].trk>>1, md1c[i].trk&1, md1c[i].sec, 0x03, md1c[i].ofs, md1c[i].size);
			}
			continue;
		} 
		disk.ReadDATA1(0x4f, 0x27, 0x01, 0x05, 0x03, buff, 0x20);
		if (!memcmp(buff, id2, sizeof(id2)-1) || dn==2)
		{
			printf("DISK 2 F܂.\n");
			for (i=0; md2a[i].sec; i++)
			{
				sprintf(fname,"MA1%02d",i);
				fcut(fname, md2a[i].trk, md2a[i].trk>>1, md2a[i].trk&1, md2a[i].sec, 0x03, md2a[i].ofs, md2a[i].size);
			}
			for (i=0; md2b[i].sec; i++)
			{
				sprintf(fname,"MB1%02d",i);
				fcut(fname, md2b[i].trk, md2b[i].trk>>1, md2b[i].trk&1, md2b[i].sec, 0x03, md2b[i].ofs, md2b[i].size);
			}
			for (i=0; md2c[i].sec; i++)
			{
				sprintf(fname,"MC1%02d",i);
				fcut(fname, md2c[i].trk, md2c[i].trk>>1, md2c[i].trk&1, md2c[i].sec, 0x03, md2c[i].ofs, md2c[i].size);
			}
		}
	}
	return 0;
}

